package com.arubanetworks.meridiansamples

import android.graphics.Matrix
import android.os.Bundle
import android.view.*
import com.arubanetworks.meridian.location.MeridianLocation
import com.arubanetworks.meridian.location.MeridianOrientation
import com.arubanetworks.meridian.maps.MapView
import com.arubanetworks.meridian.maps.Marker

/**
 * Demonstrates the use of the MapView.  It is recommended to use the SDK map fragment instead of the mapview
 */

class MapViewFragment : android.support.v4.app.Fragment(), MapView.DirectionsEventListener, MapView.MapEventListener {
    private var mapView: MapView? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val layout = inflater.inflate(R.layout.fragment_mapview, container, false)
        mapView = layout.findViewById(R.id.demo_mapview)
        mapView?.appKey = Application.APP_KEY

        // If you want to handle MapView events
        mapView?.setMapEventListener(this)

        // If you want to handle directions events
        mapView?.setDirectionsEventListener(this)

        // If you want to handle marker events
        //mapView?.setMarkerEventListener(this)

        // Set map options if desired
        val mapOptions = mapView?.options
        mapOptions?.HIDE_MAP_LABEL = true
        mapOptions?.HIDE_DIRECTIONS_CONTROLS = true
        mapView?.options = mapOptions

        // If you want to load a map other than the default one
        // It is recommended to do this after setting the map options
        mapView?.mapKey = Application.MAP_KEY
        return layout
    }

    override fun onResume() {
        super.onResume()
        mapView?.onResume()
    }

    override fun onPause() {
        super.onPause()
        mapView?.onPause()
    }

    override fun onDestroy() {
        super.onDestroy()
        mapView?.onDestroy()
    }


    //
    // MapViewListener methods
    //
    override fun onMapLoadStart() {}
    override fun onMapLoadFinish() {}
    override fun onPlacemarksLoadFinish() {}
    override fun onMapRenderFinish() {}
    override fun onMapLoadFail(tr: Throwable) {}
    override fun onMapTransformChange(transform: Matrix) {}
    override fun onLocationUpdated(meridianLocation: MeridianLocation) {}
    override fun onOrientationUpdated(orientation: MeridianOrientation) {}
    override fun onLocationButtonClick(): Boolean {return false}
    //
    // DirectionsEventListener methods
    //
    override fun onDirectionsReroute() {}
    override fun onDirectionsClick(marker: Marker): Boolean {return false}
    override fun onDirectionsStart(): Boolean {return false}
    override fun onRouteStepIndexChange(index: Int): Boolean {return false}
    override fun onDirectionsClosed(): Boolean {return false}
    override fun onDirectionsError(tr: Throwable): Boolean {return false}
    override fun onUseAccessiblePathsChange() {}
}
